#include "FreqSwitcher.h"
#include "DeviceHubWindow.h"
#include <iostream>
#include <QDateTime>

FreqSwitcher::FreqSwitcher(QObject *parent) : DeviceBase(parent)
{
    this->devType = "06";
    connect(&this->serialUtil, &QSerialPortUtil::dataRecieved,
            this, &FreqSwitcher::dataReceivedHandler);
    connect(&this->serialUtilB, &QSerialPortUtil::dataRecieved,
            this, &FreqSwitcher::dataBReceivedHandler);

    connect(this, &FreqSwitcher::sendDataToDraw,
            ((DeviceHubWindow *)this->parent())->freqSwitForm, &FreqSwitcherForm::drawDeviceFrameOnForm);
    connect(this, &FreqSwitcher::sendCommandToDisplay,
            ((DeviceHubWindow *)this->parent())->freqSwitForm, &FreqSwitcherForm::displayDeviceCommandOnForm);

    connect(((DeviceHubWindow *)this->parent())->kafkaConsumer, &QKafkaConsumer::messageRecieved,
            this, &FreqSwitcher::commandReceivedHandler);

    kafkaProducer.setBrokers(SettingConfig::getInstance().KAFKA_BROKERS);
    kafkaProducer.setTopic(SettingConfig::getInstance().KAFKA_DATA_TOPIC);
    kafkaProducer.createProducer();

    this->protocol = DeviceProtocolBase::deviceProtocolFactory(devType);
}

FreqSwitcher::~FreqSwitcher()
{
    disconnect(&this->serialUtil, &QSerialPortUtil::dataRecieved,
               this, &FreqSwitcher::dataReceivedHandler);
}

void FreqSwitcher::mockReceivData()
{
    QByteArray buffer;

    // freq switcher
    buffer.append("$GLF,0,4,0,0,22000,-745,-776,0,0,0,0,0,100,100,0,0,0,1,00000,111111,111111*54").append("\r\n");
    buffer.append("$GLC,0*54").append("\r\n");
    buffer.append("$GLN,0,192.168.000.123,255.255.255.000,192.168.000.001,192.168.001.123,255.255.255.000,192.168.001.001,255.255.255.255,3000,2000,2001*75").append("\r\n");

    this->dataReceivedHandler(buffer);
}

void FreqSwitcher::dataReceivedHandler(QByteArray data)
{
    this->dataBuff.append(data);

    QList<QByteArray> frameList = protocol->extractFrameList(this->dataBuff);
    if (frameList.size() > 0)
    {
        this->dataBuff.clear();
        frameParse(frameList);
    } else if (dataBuff.size() > 1024)
    {
        dataBuff.clear();
    }
}

void FreqSwitcher::dataBReceivedHandler(QByteArray data)
{
    this->dataBuffB.append(data);
    QList<QByteArray> frameListB = protocol->extractFrameList(this->dataBuffB);

    if (frameListB.size() > 0)
    {
        this->dataBuffB.clear();
        frameParse(frameListB);
    } else if (dataBuffB.size() > 1024)
    {
        dataBuffB.clear();
    }
}

void FreqSwitcher::frameParse(QList<QByteArray> frameList)
{
    for (int i = 0; i < frameList.size(); i++)
    {
        QByteArray frameByte = frameList.at(i);

        int frameType = protocol->checkFrame(frameByte);
        DeviceFrameBaseDto * frameDto = protocol->frameFactory(frameType);
        if (frameDto != nullptr)
        {
            // ★解析成数据对象
            bool parse = protocol->parseDeviceFrameData(frameByte, frameDto, frameType);

            // 解析成功
            if (parse == true)
            {
                QDateTime now = QDateTime::currentDateTime();
                frameDto->timestamp = now.toString("yyyy-MM-dd HH:mm:ss.zzz");
                frameDto->milisecond = now.toMSecsSinceEpoch();
                frameDto->rawFrame = frameByte;

                frameDto->devCode = devCode;

                this->afterFrameParse(frameDto);
            }

            // 在此处释放内存，不影响后续显示
            // 不在此处释放内存则会导致内存持续增加
            // 具体原因不明
            delete frameDto;
        }
    }
}
void FreqSwitcher::afterFrameParse(DeviceFrameBaseDto * frameDto)
{
//    std::cout << "frame type: " << typeid(* frameDto).name() << std::endl;
//    std::cout << frameDto->rawFrame.toStdString() << std::endl;

    // 0. 输出到日志文件中
    QString date = frameDto->timestamp.mid(0, 10);

    // 1. 原始字节数组数据
    QString filename = "raw_" + devCode + ".log";
    QString content = frameDto->timestamp + " [recv] " + frameDto->rawFrame.left(frameDto->rawFrame.size() - FRAME_TAIL.size());
    QLogUtil::writeRawDataLogByDate(date, filename, content);

    // 2. 解析后的json数据
    QString frameFilename = "frame_" + devCode + ".log";
    QString frameContent = frameDto->timestamp + " [recv] " + QJsonDocument(frameDto->toJSON()).toJson(QJsonDocument::Compact);
    QLogUtil::writeChannelDataLogByDate(date, frameFilename, frameContent);


    // 3. 输出到中间件，执行后续处理过程
    if (SettingConfig::getInstance().NEED_KAFKA == 1)
    {
        QJsonObject jsonObj = frameDto->toJSON();
        jsonObj.insert("clientId", SettingConfig::getInstance().CLIENT_ID);
        jsonObj.insert("deviceId", deviceId);
        kafkaProducer.produceMessage(QString(QJsonDocument(jsonObj).toJson(QJsonDocument::Compact)));
    }

    // 4. 在界面上简单显示相差数据结果
    emit this->sendDataToDraw(frameDto);
}

void FreqSwitcher::sendDataToSerial(QByteArray data)
{
    CommandReplyDto replyDto;
    replyDto.devCode = devCode;
    replyDto.commandId = commandId;
    replyDto.rawCommand = rawCommandBytes;

    data.append(FRAME_TAIL);
    if (SettingConfig::getInstance().WORK_MODE == "real")
    {
        if (serialUtil.isOpen() == true)
        {
            this->serialUtil.sendData(data);
        } else if (serialUtilB.isOpen() == true)
        {
            this->serialUtilB.sendData(data);
        } else
        {
            replyDto.cmdStatus = 0;
            replyDto.remarks = "serialport not avilable";

            // 3. 输出到中间件，执行后续处理过程
            if (SettingConfig::getInstance().NEED_KAFKA == 1)
            {
                kafkaProducer.produceMessage(SettingConfig::getInstance().KAFKA_CMDCB_TOPIC,
                                             QString(QJsonDocument(replyDto.toJSON()).toJson(QJsonDocument::Compact)));
            }
            return;
        }
    }
    this->serialUtil.sendData(data);

    // 记录日志
    // 0. 输出到日志文件中
    QDateTime now = QDateTime::currentDateTime();
    QString date = now.toString("yyyy-MM-dd");

    // 1. 原始字节数组数据
    QString filename = "rawCmd_" + devCode + ".log";
    QString content = now.toString("yyyy-MM-dd HH:mm:ss.zzz") + " [send] " + data.left(data.size() - FRAME_TAIL.size());
    QLogUtil::writeRawDataLogByDate(date, filename, content);

    // reply success
    replyDto.cmdStatus = 1;

    // 2. 解析后的json数据
    QString frameFilename = "frame_" + devCode + ".log";
    QString frameContent = now.toString("yyyy-MM-dd HH:mm:ss.zzz") + " [reply] " + QJsonDocument(replyDto.toJSON()).toJson(QJsonDocument::Compact);
    QLogUtil::writeChannelDataLogByDate(date, frameFilename, frameContent);

    // 3. 输出到中间件，执行后续处理过程
    if (SettingConfig::getInstance().NEED_KAFKA == 1)
    {
        kafkaProducer.produceMessage(SettingConfig::getInstance().KAFKA_CMDCB_TOPIC,
                                     QString(QJsonDocument(replyDto.toJSON()).toJson(QJsonDocument::Compact)));
    }

    std::cout << content.toStdString() << std::endl;
}

void FreqSwitcher::commandReceivedHandler(QJsonObject command)
{
    if (command.contains("deviceType") == false || command.value("deviceType").toString() != "06")
    {
        return;
    }

    if (command.contains("deviceId") == false || command.value("deviceId").toString() != deviceId)
    {
        return;
    }

    std::cout << QString(QJsonDocument(command).toJson(QJsonDocument::Compact)).toStdString() << std::endl;

    // 记录日志
    // 0. 输出到日志文件中
    QDateTime now = QDateTime::currentDateTime();
    QString date = now.toString("yyyy-MM-dd");

    // 1. 原始字节数组数据
    QString filename = "cmd_" + devCode + ".log";
    QString content = now.toString("yyyy-MM-dd HH:mm:ss.zzz") + " [recv] " + command.find("cmdStr")->toString();
    QLogUtil::writeChannelDataLogByDate(date, filename, content);

    QByteArray commandBytes = protocol->generateSettingCommand(devCode, command.value("command").toString(), command.value("params").toString());
    command.insert("rawCommand", QString::fromUtf8(commandBytes));
    this->commandId = command.value("commandId").toString();
    this->rawCommandBytes = commandBytes;
    this->sendDataToSerial(commandBytes);

    // display on page
    emit sendCommandToDisplay(command);
}

